'''
Created on 06.11.2011

@author: tohe
'''
import multiprocessing

from time import time, strftime, gmtime
from copy_reg import pickle
from types import MethodType

from dsc_suite.opt.monte_carlo_adjusted import generate_monte_carlo_data
from dsc_suite.ds.data_structure import COST_CRITERIA_LIST
from dsc_suite.ds.slicing_tree import SlicingTree
from dsc_suite.tools.benchmarks import YAL

def _pickle_method(method):
    "Doing pickle"
    func_name = method.im_func.__name__
    obj = method.im_self
    cls = method.im_class
    return _unpickle_method, (func_name, obj, cls)

def _unpickle_method(func_name, obj, cls):
    "Doing unpickle"
    for cls in cls.mro():
        try:
            func = cls.__dict__[func_name]
        except KeyError:
            pass
        else:
            break
    return func.__get__(obj, cls)

def main_mc():
    pickle(MethodType, _pickle_method, _unpickle_method)
    bench = YAL("ami33.yal")
    bench.to_3d()
    ds = SlicingTree(bench)
    worker_pool = multiprocessing.Pool(processes=8)
    representations = []
    i = 0
    while i < 100000:
        results= []
        k = 0
        while i < 100000 and k < 8:
            results.append(worker_pool.apply_async(ds.get_random_representation))
            k +=1
            i +=1
        for res in results:
            representations.append(res.get())
    worker_pool.close()
    worker_pool = multiprocessing.Pool(processes=8)
    i = 0
    while i < 100000:
        results= []
        k = 0
        while i < 100000 and k < 8:
            results.append(worker_pool.apply_async(ds.cost_evaluation, (representations[i], COST_CRITERIA_LIST.keys())))
            k +=1
            i +=1
        for res in results:
            res.get()
            
    worker_pool.close()
    print len(representations)

def main_single():
    bench = YAL("ami33.yal")
    bench.to_3d()
    ds = SlicingTree(bench)
    representations = []
    i = 0
    while i < 100000:
        representations.append(ds.get_random_representation())
        i += 1
    for rep in representations:
        ds.cost_evaluation(rep,COST_CRITERIA_LIST.keys())
    
if __name__ == "__main__":
    start = time()
    main_mc()
    end = time()
    print "Multi-Process: %s" % (strftime("%d.%m.%Y um %H:%M:%S Uhr", gmtime(end-start)))
    start = time()
    main_single()
    end = time()
    print "Single-Process: %s" % (strftime("%d.%m.%Y um %H:%M:%S Uhr", gmtime(end-start)))