"""sets the standard paths for files of the environment

This module sets the paths for the standard folders needed for the GUI. The paths are created from the path of the module dsc. You can change the path by creating your own structure, but make sure the paths are correct and the folders exists.
Warning: Leave the structure of the DSC program intact! The program will raise an exception if the folders do not exist.

@author: Robert Fischbach
@author: Tobias Heimpold
@copyright: Copyright (C) 2011
@license: This program is free software; you can redistribute it and/or modify it 
          under the terms of the GNU General Public License as published by the 
          Free Software Foundation; either version 3 of the License, or (at your 
          option) any later version.
          This program is distributed in the hope that it will be useful, but 
          WITHOUT ANY WARRANTY; without even the implied warranty of 
          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
          Public License for more details.
          You should have received a copy of the GNU General Public License along 
          with this program; if not, see <http://www.gnu.org/licenses/>.
@contact: For questions and bugs send an email to <fischbach (at) ifte.de>

@var FOLDER_FOR_BENCHMARKS: The path to the standard folder where the benchmark files are saved.
@type FOLDER_FOR_BENCHMARKS: string

@var FOLDER_FOR_DATA: The path to the standard folder where the generated data files are saved.
@type FOLDER_FOR_DATA: string

@var FOLDER_FOR_PLOTS: The path to the standard folder where the benchmark files are saved.
@type FOLDER_FOR_PLOTS: string
"""

import os
# folders without ending slash, only names

path_of_toolpaths_py = os.path.realpath(__file__)

#path_cwd = os.getcwd()
path_cwd = os.path.split(path_of_toolpaths_py)[0]
path_cwd = os.path.split(path_cwd)[0]
path_cwd = os.path.split(path_cwd)[0]
path_cwd = os.path.split(path_cwd)[0]

"""FOLDER_FOR_BENCHMARKS 
The path to the standard folder where the benchmark files are saved. 
"""
FOLDER_FOR_BENCHMARKS = os.path.join(path_cwd, 'benchmarks')

"""FOLDER_FOR_DATA 
The path to the standard folder where the generated data files are saved. 
"""
FOLDER_FOR_DATA = os.path.join(path_cwd, 'data') 

"""FOLDER_FOR_PLOTS
The path to the standard folder where the benchmark files are saved.
"""
FOLDER_FOR_PLOTS = os.path.join(path_cwd, 'plots')

#deletion for documentation
del path_of_toolpaths_py
del path_cwd
